//+------------------------------------------------------------------+
//|                                                Mom_HighClose.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green     //   Open
#property indicator_color2 Magenta   //   Close
//---- input parameters
extern int MomPeriod=2;

//---- buffers
double hBuffer[];          // High[]
double lBuffer[];          // Low[]
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,3);
   SetIndexBuffer(0,hBuffer);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,3);
   SetIndexBuffer(1,lBuffer);
//---- name for DataWindow and indicator subwindow label
   string short_name="mHL("+MomPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,MomPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| A_Momentum                                                       |
//+------------------------------------------------------------------+
int start()
  {
   int i,kvo=IndicatorCounted();
//----
   if(Bars<=MomPeriod) return(0);
//---- initial zero
   if(kvo<1)
      for(i=1;i<=MomPeriod;i++) 
         {
         hBuffer[Bars-i]=0.0;
         lBuffer[Bars-i]=0.0;
         }
//----
   i=Bars-MomPeriod-1;
   if(kvo>=MomPeriod) i=Bars-kvo-1;
   while(i>=0)
     {
      hBuffer[i]=(High[i]-Open[i]) * 10000 / High[i+MomPeriod-1];
      lBuffer[i]=(Open[i]-Low[i])  * 10000 / Low[i+MomPeriod-1] * (-1);
      i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+